#coding=utf-8
#DESC:Print average temperature factor

import tempfile
import shutil
from molFeat import *

def run():

  tmpDir = tempfile.mkdtemp()
  curMols = getCurrentMolecule()
  success = False
  selectsMoleucles = getAtomSelected()
  count = 0

  # 選択中の分子の数でループ
  for i in range(len(curMols)):

    # 選択中の分子をPDBに書き出し
    success = exportFile(tmpDir + "/" + "tmp" + str(i) + ".pdb", 1, curMols[i])
    if success == False:
      print "can't write tmp pdb"
      return

    numAtoms = getNumAtoms(curMols[i])

    selects = selectsMoleucles[count:count+numAtoms]
    count+=numAtoms

    # ファイルを開く
    f1 = open(tmpDir + "/" + "tmp"  + str(i) + ".pdb", 'r')

    # PDBから文字列を抽出
    atomNum = 0
    selectAtomNum = 0
    sum = 0
    for line in f1:
      if line[0:4] == "ATOM":
        if selects[atomNum]:
          sum += float(line[60:67])
          selectAtomNum += 1
        atomNum += 1
    
    f1.close()
    print "Molecule Name：  " + getMoleculeName(curMols[i])
    print "Number of atoms(only amino or nucleic)：  " + str(selectAtomNum)
    print "Average of temperature factor：  " + str(sum / selectAtomNum)
    shutil.rmtree(tmpDir)

if __name__ == '__main__':
	run()
